﻿using System.Security.Cryptography.X509Certificates;
using FitConnect;
using FitConnect.Models;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Logging.Abstractions;

var clientId = "";
var clientSecret = "";
PublicKey publicKey;
ILogger _logger;
Client client;
X509Certificate2 certificate;


void FluentSenderCall() {
    client.GetSender()
        .WithDestination("destinationId")
        .WithServiceType("", "")
        .WithAttachments(Array.Empty<Attachment>())
        .WithData("{\"data\":\"value\"}")
        .Submit();

    client.GetSender()
        .WithDestination("destinationId")
        .WithServiceType("", "")
        .WithAttachments(Array.Empty<Attachment>())
        .Submit();
}

void FluentSubscriberCall() {
    var submissions = client.GetSubscriber("", "")
        .GetAvailableSubmissions();

    client.GetSubscriber("", "").RequestSubmission("submissionId")
        .GetAttachments(attachments => {
            // Check if the attachments are valid
            return true;
        });
}

var logger = LoggerFactory.Create(
    builder => {
        builder.AddSimpleConsole();
        builder.SetMinimumLevel(LogLevel.Information);
    }).CreateLogger("FluentSenderTests");

logger.Log(LogLevel.Information,
    "This is a dummy client to demonstrate the usage of the FIT-Connect SDK for .NET");


client = new Client(
    FitConnectEndpoints.Create(FitConnectEndpoints.EndpointType.Development),
    "clientId", "clientSecret",
    logger: logger);

Console.WriteLine(
    "This is a dummy client to demonstrate the usage of the FIT-Connect SDK for .NET");

FluentSenderCall();
FluentSubscriberCall();
